

//=======================================================================//
#define	DS1804		1	// U/_D _INC _CS
//
#define	MCP4011		2	// U/_D _STB eeprom
#define	U_D_STB		3	// U/_D i ujemne STB
//
#define	MAX5128		4	// Dodatnie impulsy UP DOWN eeprom
#define	ELM402		5	// Dodatnie impulsy UP DOWN 3ms
#define	UPDOWN		6	// Dodatnie impulsy UP DOWN
//
#define	ELM402_		7	// Ujemne impulsy UP DOWN 3ms
#define	_UP_DOWN	8	// Ujemne impulsy UP DOWN
#define	U_DSTB		9	// U/_D i dodatnie STB


#define	TRYB			MAX5128
#define	WIPERMASK		256-1	// rozdzielczo - wane dla innych ni DS1804 i MCP4011
#define	STORAGE_TIME	10		// Czas po ktrym pozycja jest zapamitywana w potencjometrze


//=======================================================================//
#define	uchar	unsigned char
#define	byte	unsigned char
#define	uint	unsigned int
#define	word	unsigned int
#define	ulong	unsigned long
#define	true		1
#define	True		true
#define	TRUE		true
#define false		0
#define False		false
#define FALSE		false
#define LOW			0
#define	HIGH		1
#define	NONE		-1
#define	PARITYERR	-2
#define	FRAMEERR	-3
#define	OVERRUNERR	-4
#define	TIMEOUT	-5


//----------------------------------------------------------------------//
//=						Pliki doczane									=//
//=======================================================================//
#include <avr/io.h>									// IO
#include <stdio.h>									//
#include <stdlib.h>									//
#include <ctype.h>
#include <avr/sfr_defs.h>							// SFR, _BV(bit)
#include <avr/pgmspace.h>							// Flash
#define CODE PROGMEM
#include <avr/interrupt.h>							// wektory IRQ
#include <avr/wdt.h> 								// WDG
#include <avr/eeprom.h>								// Eeprom
#include <string.h>									// Stringi
#include <compat/deprecated.h>						// sbi, cbi, inb, outb, outp
#define ebi(port,bit) ( port ^= (1 << (bit)))		// Negowanie bitu na porcie
#define BAUD 		9600
#define	BAUD1		9600
#include <util/setbaud.h>							// Uart
#include <rmik/setbaud1.h>							// Uart 1
#include <util/delay.h>
#include <util/crc16.h>								// Crc16, Xmodem, Dallas
#define nop()	__asm__ __volatile__( "nop" )		// Wstawia rozkaz NOP do kodu
#define jmp()	__asm__ __volatile__( "jmp 0" )		// Wstawia rozkaz JMP do kodu
#define NOINIT __attribute__ ((section(".noinit")))
#include <avr/sleep.h>
#include <avr/power.h>
#include <avr/boot.h>


//=======================================================================//
char volatile IMPdata;
byte Wiper;


#if TRYB==MCP4011
  byte WiperEE EEMEM = 0x20;		// poowa z 64
#else
  byte WiperEE EEMEM = 0x80;		// poowa z 256
#endif
void Up();
void Down();
void Recall();
void Storage();


#define	DdrInp()	PORTB |=_BV(PB3) | _BV(PB4)		// Podciganie
#define	RdImpA()	(PINB & _BV(PB3) )
#define	RdImpB()	(PINB & _BV(PB4) )
#define	RdImpAB()	(PINB & 0x18 )
void InitInt();
void InitTimer0();
void ENirqTimer0();
void DISirqTimer0();
byte volatile Timer = STORAGE_TIME * 10;	// Timeoutr;


#define	CS_L()		PORTB &= ~(1<< PB2 )	
#define	CS_H()		PORTB |=  (1<< PB2 )
#define	STB_L		CS_L	
#define	STB_H		CS_H

#define	UD_L()		PORTB &= ~(1<< PB1 )	
#define	UD_H()		PORTB |=  (1<< PB1 )
#define	UP_L		UD_L	
#define	UP_H		UD_H

#define	DOWN_L()	PORTB &= ~(1<< PB0 )	
#define	DOWN_H()	PORTB |=  (1<< PB0 )
#define	INC_L		DOWN_L	
#define	INC_H		DOWN_H


byte auth[] CODE = "(C) 2017 AVT, Slawomir Skrzynski";
#if TRYB==DS1804
  byte type[] CODE = ": DS1804";
#elif TRYB==U_D_STB 					// U/_D _STB
  byte type[] CODE = ": U/#D & #STB";
#elif  TRYB==MCP4011				// U/_D _STB
  byte type[] CODE = ": MCP4011";
#elif TRYB==U_DSTB
  byte type[] CODE = ": U/#D & STB";
#elif TRYB==UPDOWN					// Dodatnie impulsy UP DOWN
  byte type[] CODE = ": Up & Down";
#elif TRYB==MAX5128					// Dodatnie impulsy UP DOWN
  byte type[] CODE = ": MAX5128";
#elif TRYB==ELM402					// Dodatnie impulsy UP DOWN
  byte type[] CODE = ": ELM402";
#elif TRYB==ELM402_					// Ujemne impulsy UP DOWN
  byte type[] CODE = ": ELM402#";
#elif TRYB==_UP_DOWN
  byte type[] CODE = ": #Up & #Down";
#else
  #error "Wybrano zly tryb pracy."
#endif


//=======================================================================//
// Mona zadekalrowac jako noreturn wtedy jakie 30 bajtw mozna zoszczdzi
int main()
{
byte memIMPdata=0;


	#define	WDT_TIME	WDTO_120MS
	wdt_enable( WDT_TIME );


	#if TRYB==DS1804
	  #warning "zweryfikowac"
	  INC_H(); CS_H(); 
	#elif TRYB==U_D_STB || TRYB==MCP4011				// U/_D _STB
	  CS_H(); UD_H();
	  #ifdef WIPERMASK
		#undef WIPERMASK
		#define	WIPERMASK	64-1						// 64 pozycje
	  #endif
	#elif TRYB==U_D_STB
	  CS_L(); UD_H();
	#elif TRYB==UPDOWN || TRYB==MAX5128	|| TRYB==ELM402	// Dodatnie impulsy UP DOWN
	  UP_L(); DOWN_L();
	  #if TRYB==MAX5128
		#ifdef WIPERMASK
		  #undef WIPERMASK
		  #define WIPERMASK	128-1						// 128 pozycji
		#endif
	  #endif
	#elif TRYB==_UP_DOWN || TRYB==ELM402_
	  UP_H(); DOWN_H();
	#elif TRYB==U_DSTB									// U/_D i dodatnie stroby
	  STB_L();
	#else
	  #error "Wybrano zly tryb pracy."
	#endif


	DDRB |= (1<<PB0) | (1<<PB1) | (1<<PB2);
	Recall();


	DdrInp();
	InitInt();
	InitTimer0();
	sei();


	while( TRUE )
		{
		wdt_reset();


		

/*
static volatile byte pb;
if ( pb != RdImpAB() )
	{
	pb = RdImpAB();
	if ( !RdImpA() )
		{
		_delay_us(100);
		if ( RdImpB() )
			{
			IMPdata++;
			}
		else
			{
			IMPdata--;
			}
		}
		_delay_ms(1);
	} 
*/

		if ( memIMPdata != IMPdata )	// Jeli zmiana pooenia impulsatora
			{
			if( IMPdata > memIMPdata )	// W gr
				{
				Up();
				}
			else 
				{
				Down();
				}
			Wiper &= WIPERMASK;
			memIMPdata = IMPdata;
			Timer = STORAGE_TIME * 10;	// Timeout
			#if STORAGE_TIME * 10 > 0xFF
			  #error "przpelnianie"
			#endif
			}


//		if( Timer )		
//			{
//			Timer--;
//			_delay_ms(1);
			if ( Timer==1 )				// Jeli zero
				{
				Timer=0;
				Storage();				// Zapisz pozycj w eeprom
/*
//todo: aby sztuczka zadziaaa, przerwanie musiaoby by doprowadzone do linii INT0
		bo tylko ona w trym AVR'ku moe generowa IRQ wyzwalane poziomen.
				przerwania wyzywalane poziomem (int0 musi byc SIGNAL a nie INTERRUPT)
				w przerwaniu przestawienie z wyzwalania poziomem na wyzwalanie zboczem opadajcym
				wdt_disable();
				set_sleep_mode( SLEEP_MODE_IDLE ); sleep_mode();
				wdt_enable( WDT_TIME );
*/
				}
//			}


//todo: Aby usypie trzeba uaktywni IRQ od timera aby odlicza czas, wystarczy budzenie co 100ms)
//		ale wtedy wdg na 120ms i nie trzeba bedzie go blokowac w trybie upienia
//		wdt_disable();
		set_sleep_mode( SLEEP_MODE_IDLE ); sleep_mode();
//		wdt_enable( WDT_TIME );
		}
}


//----------------------------------------------------------------------//
void Up()
{
	if ( Wiper++ > WIPERMASK ) Wiper = WIPERMASK;


	#if TRYB==DS1804
		UD_H();		// Up
		INC_H();
		CS_L();
		INC_L();	// Strob
		CS_H();		// Non-Storage bo INC=0
		INC_H();
	#elif TRYB==MCP4011
		UD_H();
		CS_L();
		UD_L();
		UD_H();
		CS_H();
	#elif TRYB==U_D_STB
		UD_H();
		CS_L();
		CS_H();
	#elif TRYB==UPDOWN || TRYB==MAX5128 || TRYB==ELM402
		UP_H();
		#if TRYB==ELM402
		_delay_ms(3);
		#endif
		UP_L();
	#elif TRYB==U_DSTB
		UD_H();
		CS_H();
		UD_L();
		UD_H();
		CS_L();
	#elif TRYB==_UP_DOWN || TRYB==ELM402_
		UP_L();
		#if TRYB==ELM402_
		_delay_ms(3);
		#endif
		UP_H();
	#else
	  #error "Nieznany typ ukladu"
	#endif
}


//----------------------------------------------------------------------//
void Down()
{
	if ( Wiper ) Wiper--;


	#if TRYB==DS1804
		UD_L();		// Down
		INC_H();
		CS_L();
		INC_L();	// Strob
		CS_H();		// Non-Storage bo INC=0
		INC_H();
	#elif TRYB==MCP4011
		UD_L();
		CS_L();
		UD_H();
		UD_L();
		CS_H();
	#elif TRYB==U_D_STB
		UD_L();
		CS_L();
		CS_H();
	#elif TRYB==UPDOWN || TRYB==MAX5128 || TRYB==ELM402
		DOWN_H();
		#if TRYB==ELM402
		_delay_ms(3);
		#endif
		DOWN_L();
	#elif TRYB==U_DSTB
		UD_L();
		CS_H();
		UD_H();
		UD_L();
		CS_L();
	#elif TRYB==_UP_DOWN || TRYB==ELM402_
		DOWN_L();
		#if TRYB==ELM402_
		_delay_ms(3);
		#endif
		DOWN_H();
	#else
	  #error "Nieznany typ ukladu"
	#endif
}


//----------------------------------------------------------------------//
void Storage()
{
byte static w=128;


	if ( w==Wiper ) return;
	w = Wiper;


	#if TRYB==DS1804
  #warning "zweryfikowac"
		INC_H();
		CS_L();
		CS_H();		// Storage bo INC=1
		_delay_ms(10);
	#elif TRYB==MAX5128
		UP_H();
		DOWN_H();
		DOWN_L();
		UP_L();
		_delay_ms(14);
	#elif TRYB==ELM402
	#else
		if ( Wiper != eeprom_read_byte( &WiperEE ) ) eeprom_write_byte( &WiperEE, Wiper );
	#endif
}


//----------------------------------------------------------------------//
void Recall()
{
#if TRYB!=MAX5128 && TRYB!=DS1804
#warning "Wklad bez EEPROM"
byte x, w;


	w = eeprom_read_byte( &WiperEE );
	for(x=0; x<WIPERMASK; x++){ Down(); wdt_reset(); }	// Potencjometr na 0
	for(x=0; x<w; x++){ Up(); wdt_reset(); }			// Ustaw "lizgacz"
	Wiper = w;
#endif
}


//======================================================================//
//			Nicjalizacja IRQ od wejcia INT 							//
//----------------------------------------------------------------------//
void InitInt()
{
//	MCUCR |= (2<<ISC00);	//Konfiguracja przerwania INT0: zbocze opadajce
//	GIMSK |= (1<<INT0);		//Odblokowanie przerwania INT0

	PCMSK |= _BV(PCINT3);	// Int od PB3
	GIMSK |= _BV(PCIE);		//Odblokowanie przerwania 
}


//----------------------------------------------------------------------//
//			Obsuga IRQ od wejcia INT 								//
//----------------------------------------------------------------------//
//SIGNAL( INT0_vect )			// Musi by SIGNAL a nie INTERRUPT  jeli wyzwalanie poziomem
SIGNAL( PCINT0_vect )
{
	if ( !RdImpA() )			// Jeli zbocze opadajce
	{
		if ( RdImpB() )		// Wstawiajc negacj ("!") zmieniamy kierunek
			{
			IMPdata++;
			}
		else
			{
			IMPdata--;
			}
	}
}


//=======================================================================//
//     Init timera dla irq                                       		//
//----------------------------------------------------------------------//
void InitTimer0()
{
	//--- Init timera w trybie 0 ---
//	TCCR0 = 0x7;      					// Preskaler na 1024
//	TIMSK |= ( 1<<TOIE0 );    			// Zezwolenie na IRQ od przepenienia timera

	//--- Init timera w trybie CTC ---
	TCCR0A = (1<<WGM01);				// tryb CTC
	TCCR0B |= 0x5;						// Preskaler na 1024
	OCR0A = 100 * F_CPU/1000 / 1024;	// 1ms * F_CPU/1000 / PRESKALER

	ENirqTimer0();		 		   		// Zezwolenie na IRQ od porwnania timera
}


//----------------------------------------------------------------------//
//					Wycza IRQ od timera
//----------------------------------------------------------------------//
void DISirqTimer0()
{
	TIMSK &= ~( 1<<OCIE0A ); 	   	// Zezwolenie na IRQ od porwnania timera
}


//----------------------------------------------------------------------//
//					Wcza IRQ od timera
//----------------------------------------------------------------------//
void ENirqTimer0()
{
	TIFR |= _BV(OCF0A);				// Kasuje flag IRQ
	TIMSK |= ( 1<<OCIE0A ); 		// Zezwolenie na IRQ od porwnania timera
}


//----------------------------------------------------------------------//
//     Obsuga IRQ od timera 0 (tryb CTC)                               //
//																		//
// Przerwanie co:					100ms 						//
//----------------------------------------------------------------------//
INTERRUPT(TIMER0_COMPA_vect)
{
	if ( Timer ) Timer--;
}


//======================================================================//

